Package org.apache.velocity.runtime.resource.loader

# Class StringResourceLoader

java.lang.Object
org.apache.velocity.runtime.resource.loader.ResourceLoader
org.apache.velocity.runtime.resource.loader.StringResourceLoader

public class StringResourceLoader extends ResourceLoader
Resource loader that works with Strings. Users should manually add resources to the repository that is used by the resource loader instance. Below is an example configuration for this loader. Note that 'repository.class' is not necessary; if not provided, the factory will fall back on using `StringResourceRepositoryImpl` as the default.

     resource.loaders = string
     resource.loader.string.description = Velocity StringResource loader
     resource.loader.string.class = org.apache.velocity.runtime.resource.loader.StringResourceLoader
     resource.loader.string.repository.name = MyRepositoryName (optional, to avoid using the default repository)
     resource.loader.string.repository.class = org.apache.velocity.runtime.resource.loader.StringResourceRepositoryImpl

Resources can be added to the repository like this:

       StringResourceRepository repo = StringResourceLoader.getRepository();

       String myTemplateName = "/some/imaginary/path/hello.vm";
       String myTemplate = "Hi, ${username}... this is some template!";
       repo.putStringResource(myTemplateName, myTemplate);

After this, the templates can be retrieved as usual.

If there will be multiple StringResourceLoaders used in an application, you should consider specifying a 'resource.loader.string.repository.name = foo' property in order to keep you string resources in a non-default repository. This can help to avoid conflicts between different frameworks or components that are using StringResourceLoader. You can then retrieve your named repository like this:

       StringResourceRepository repo = StringResourceLoader.getRepository("foo");

and add string resources to the repo just as in the previous example.

If you have concerns about memory leaks or for whatever reason do not wish to have your string repository stored statically as a class member, then you should set 'resource.loader.string.repository.static = false' in your properties. This will tell the resource loader that the string repository should be stored in the Velocity application attributes. To retrieve the repository, do:

       StringResourceRepository repo = velocityEngine.getApplicationAttribute("foo");

If you did not specify a name for the repository, then it will be stored under the class name of the repository implementation class (for which the default is 'org.apache.velocity.runtime.resource.util.StringResourceRepositoryImpl'). Incidentally, this is also true for the default statically stored repository.

Whether your repository is stored statically or in Velocity's application attributes, you can also manually create and set it prior to Velocity initialization. For a static repository, you can do something like this:

       StringResourceRepository repo = new MyStringResourceRepository();
       repo.magicallyAddSomeStringResources();
       StringResourceLoader.setRepository("foo", repo);

Or for a non-static repository:

       StringResourceRepository repo = new MyStringResourceRepository();
       repo.magicallyAddSomeStringResources();
       velocityEngine.setApplicationAttribute("foo", repo);

Then, assuming the 'resource.loader.string.repository.name' property is set to 'some.name', the StringResourceLoader will use that already created repository, rather than creating a new one.

Since:
  1.5
Version:
  $Id$
Author:
  Eelco Hillenius, Henning P. Schmiedehausen, Nathan Bubna

## Field Summary

Fields
Modifier and Type
Field
Description
`protected StringResourceRepository`
`repository`
the repository used internally by this resource loader
`static final String`
`REPOSITORY_CLASS`
Key to look up the repository implementation class.
`static final String`
`REPOSITORY_CLASS_DEFAULT`
The default implementation class.
`static final String`
`REPOSITORY_ENCODING`
Key to look up the repository char encoding.
`static final String`
`REPOSITORY_NAME`
Key to look up the name for the repository to be used.
`static final String`
`REPOSITORY_NAME_DEFAULT`
The default name for string resource repositories ('org.apache.velocity.runtime.resource.util.StringResourceRepository').
`static final String`
`REPOSITORY_STATIC`
Key to determine whether the repository should be set as the static one or not.
`static final boolean`
`REPOSITORY_STATIC_DEFAULT`
By default, repositories are stored statically (shared across the VM).
`protected static final Map<String,StringResourceRepository>`
`STATIC_REPOSITORIES`

### Fields inherited from class org.apache.velocity.runtime.resource.loader.ResourceLoader

`className, isCachingOn, log, modificationCheckInterval, rsvc`

## Constructor Summary

Constructors
Constructor
Description
`StringResourceLoader()`

## Method Summary

Modifier and Type
Method
Description
`static void`
`clearRepositories()`
Removes all statically stored `StringResourceRepository`s.
`StringResourceRepository`
`createRepository(String className, String encoding)`
`long`
`getLastModified(Resource resource)`
Get the last modified time of the InputStream source that was used to create the template.
`static StringResourceRepository`
`getRepository()`
Returns a reference to the default static repository.
`static StringResourceRepository`
`getRepository(String name)`
Returns a reference to the repository stored statically under the specified name.
`Reader`
`getResourceReader(String name, String encoding)`
Get a reader so that the Runtime can build a template with it.
`void`
`init(ExtProperties configuration)`
Initialize the template loader with a a resources class.
`boolean`
`isSourceModified(Resource resource)`
Given a template, check to see if the source of InputStream has been modified.
`static StringResourceRepository`
`removeRepository(String name)`
Removes the `StringResourceRepository` stored under the specified name.
`boolean`
`resourceExists(String name)`
Overrides superclass for better performance.
`static void`
`setRepository(String name, StringResourceRepository repo)`
Sets the specified `StringResourceRepository` in static storage under the specified name.

### Methods inherited from class org.apache.velocity.runtime.resource.loader.ResourceLoader

`buildReader, commonInit, getClassName, getModificationCheckInterval, isCachingOn, setCachingOn, setModificationCheckInterval`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### REPOSITORY_STATIC

public static final String REPOSITORY_STATIC
Key to determine whether the repository should be set as the static one or not.

Since:
  1.6
See Also:
  - Constant Field Values

### REPOSITORY_STATIC_DEFAULT

public static final boolean REPOSITORY_STATIC_DEFAULT
By default, repositories are stored statically (shared across the VM).

Since:
  1.6
See Also:
  - Constant Field Values

### REPOSITORY_CLASS

public static final String REPOSITORY_CLASS
Key to look up the repository implementation class.

See Also:
  - Constant Field Values

### REPOSITORY_CLASS_DEFAULT

public static final String REPOSITORY_CLASS_DEFAULT
The default implementation class.

### REPOSITORY_NAME

public static final String REPOSITORY_NAME
Key to look up the name for the repository to be used.

Since:
  1.6
See Also:
  - Constant Field Values

### REPOSITORY_NAME_DEFAULT

public static final String REPOSITORY_NAME_DEFAULT
The default name for string resource repositories ('org.apache.velocity.runtime.resource.util.StringResourceRepository').

Since:
  1.6

### REPOSITORY_ENCODING

public static final String REPOSITORY_ENCODING
Key to look up the repository char encoding.

See Also:
  - Constant Field Values

### STATIC_REPOSITORIES

protected static final Map<String,StringResourceRepository> STATIC_REPOSITORIES

### repository

protected StringResourceRepository repository
the repository used internally by this resource loader

## Constructor Details

### StringResourceLoader

public StringResourceLoader()

## Method Details

### getRepository

public static StringResourceRepository getRepository()
Returns a reference to the default static repository.

Returns:
  default static repository

### getRepository

public static StringResourceRepository getRepository(String name)
Returns a reference to the repository stored statically under the specified name.

Parameters:
  `name` -
Returns:
  named repository
Since:
  1.6

### setRepository

public static void setRepository(String name, StringResourceRepository repo)
Sets the specified `StringResourceRepository` in static storage under the specified name.

Parameters:
  `name` -
  `repo` -
Since:
  1.6

### removeRepository

public static StringResourceRepository removeRepository(String name)
Removes the `StringResourceRepository` stored under the specified name.

Parameters:
  `name` -
Returns:
  removed repository
Since:
  1.6

### clearRepositories

public static void clearRepositories()
Removes all statically stored `StringResourceRepository`s.

Since:
  1.6

### init

public void init(ExtProperties configuration)
Description copied from class: `ResourceLoader`
Initialize the template loader with a a resources class.

Specified by:
  `init` in class `ResourceLoader`
Parameters:
  `configuration` -
See Also:
  - `ResourceLoader.init(org.apache.velocity.util.ExtProperties)`

### createRepository

public StringResourceRepository createRepository(String className, String encoding)

Parameters:
  `className` -
  `encoding` -
Returns:
  created repository
Since:
  1.6

### resourceExists

public boolean resourceExists(String name)
Overrides superclass for better performance.

Overrides:
  `resourceExists` in class `ResourceLoader`
Parameters:
  `name` - resource name
Returns:
  whether resource exists
Since:
  1.6

### getResourceReader

public Reader getResourceReader(String name, String encoding) throws ResourceNotFoundException
Get a reader so that the Runtime can build a template with it.

Specified by:
  `getResourceReader` in class `ResourceLoader`
Parameters:
  `name` - name of template to get.
  `encoding` - asked encoding
Returns:
  Reader containing the template.
Throws:
  `ResourceNotFoundException` - Ff template not found in the RepositoryFactory.
Since:
  2.0

### isSourceModified

public boolean isSourceModified(Resource resource)
Description copied from class: `ResourceLoader`
Given a template, check to see if the source of InputStream has been modified.

Specified by:
  `isSourceModified` in class `ResourceLoader`
Parameters:
  `resource` -
Returns:
  whether resource was modified
See Also:
  - `ResourceLoader.isSourceModified(org.apache.velocity.runtime.resource.Resource)`

### getLastModified

public long getLastModified(Resource resource)
Description copied from class: `ResourceLoader`
Get the last modified time of the InputStream source that was used to create the template. We need the template here because we have to extract the name of the template in order to locate the InputStream source.

Specified by:
  `getLastModified` in class `ResourceLoader`
Parameters:
  `resource` -
Returns:
  last modified timestamp
See Also:
  - `ResourceLoader.getLastModified(org.apache.velocity.runtime.resource.Resource)`